package prodotti_fornitori;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Properties;

public class DbHandler {

    private Connection con;
    private final Properties connectionProperties;

    private final static String USER="postgres";
    private final static String PASSWORD="sa";
    private final static String DB_URL="jdbc:postgresql:prove_luigi";
    private static final DbHandler ourInstance = new DbHandler();
    public static DbHandler getInstance() {
        return ourInstance;
    }

    private DbHandler() {

        this.connectionProperties = new Properties();
        this.connectionProperties.put("user", DbHandler.USER);
        this.connectionProperties.put("password", DbHandler.PASSWORD);

        try {
            Class.forName("org.postgresql.Driver");
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    private Connection getConnection() throws SQLException {
        if (this.con == null || this.con.isClosed()) {
            this.con = DriverManager.getConnection(DB_URL, this.connectionProperties);
        }
        return this.con;
    }

    public PreparedStatement getPreparedStatement(String query) throws SQLException {
        return this.getConnection().prepareStatement(query);
    }

    public void closeConnection() throws SQLException {
        if(this.con!=null)
            this.con.close();
    }

}
